import OrderedObjectManager, Globals
from AccessControl import getSecurityManager
from OFS import Folder

manage_addOrderedFolderForm = Globals.DTMLFile('dtml/folderAdd', globals())

def manage_addOrderedFolder(self, id, title='',
                            createPublic=0,
                            createUserF=0,
                            REQUEST=None):
    """Add a new Folder object with id *id*.

    If the 'createPublic' and 'createUserF' parameters are set to any true
    value, an 'index_html' and a 'UserFolder' objects are created respectively
    in the new folder.
    """
    ob=OrderedFolder()
    ob.id=str(id)
    ob.title=title
    self._setObject(id, ob)
    ob=self._getOb(id)

    checkPermission=getSecurityManager().checkPermission    

    if createUserF:
        if not checkPermission('Add User Folders', ob):
            raise 'Unauthorized', (
                  'You are not authorized to add User Folders.'
                  )
        ob.manage_addUserFolder()

    if createPublic:
        if not checkPermission('Add Documents, Images, and Files', ob):
            raise 'Unauthorized', (
                  'You are not authorized to add DTML Documents.'
                  )
        ob.manage_addDTMLDocument(id='index_html', title='')

    if REQUEST is not None:
        return self.manage_main(self, REQUEST, update_menu=1)


class OrderedFolder(OrderedObjectManager.OrderedObjectManager, Folder.Folder):
    ''' '''
    meta_type = 'Ordered Folder'

    manage_options = Folder.Folder.manage_options


Globals.default__class_init__(OrderedFolder)
